   import java.awt.* ;

    public class ObjetFourmiReine extends ObjetFourmi {
    
      private ObjetFourmiLarve [] tablarves = new ObjetFourmiLarve [3];
   
       public ObjetFourmiReine(Simulation s, ObjetFourmiliere f, int x0, int y0, int id0, int idgrp0){
         super (s, f, x0, y0, id0, idgrp0);
         for (int i=0; i<3; i++){
            tablarves[i] = new ObjetFourmiLarve (s, f, x0, y0, i, idgrp0);
            simu.listeObjetsVisibles.add (tablarves[i]) ;
         }
      }
   
       public ObjetFourmiReine(Simulation s, ObjetFourmiliere f, int x0, int y0, int sens, int id0, int idgrp0){
         super (s, f, x0, y0, sens, id0, idgrp0);
         for (int i=0; i<3; i++){
            tablarves[i] = new ObjetFourmiLarve (s, f, x0, y0, i, idgrp0);
            simu.listeObjetsVisibles.add (tablarves[i]) ;
         }
      }
   
       public void run() {
       
         switch (etatPrimaire) {
         
            case (ETAT_AU_NID) :
               if(fourmiliere.getStock()>300){
                  int i=0;
                  while (!tablarves[i].disponible()){
                     i++;
                  }
                  if (i<3){
                     fourmiliere.enleveStock(300);
							System.out.println("Reine "+getId()+"("+getIdGroup()+") : Je lance l'incubation de ma larve "+i); 
                     tablarves[i].lancerIncubation();
                  }
               }
               break;
         
         }
      }
   
   //------------------------------------------------------------
   /** 
   * Dessin 2D de l'objet 
   */
       public void draw(Graphics g, double facteurZoom) {
         g.setColor(new Color (getRed(), getGreen(), getBlue()));
         g.fillRect((int)(x*facteurZoom), (int)(y*facteurZoom), 
               (int)(2*(facteurZoom+1)), (int)(2*(facteurZoom+1))) ;
      }
   }