   import java.awt.* ;

    public class ObjetFourmiLarve extends ObjetFourmi {
   
       public ObjetFourmiLarve(Simulation s, ObjetFourmiliere f, int x0, int y0, int id0, int idgrp0){
         super (s, f, x0, y0, id0, idgrp0);
         etatPrimaire = ETAT_ATTENTE_INCUBATION ;
      }
   
       public ObjetFourmiLarve(Simulation s, ObjetFourmiliere f, int x0, int y0, int sens, int id0, int idgrp0){
         super (s, f, x0, y0, sens, id0, idgrp0);
         etatPrimaire = ETAT_ATTENTE_INCUBATION ;
      }
   
       public void run() {
       
         switch (etatPrimaire) {
         
            case (ETAT_ATTENTE_INCUBATION) : 
               //System.out.println("Larve "+getId()+"("+getIdGroup()+") : J'attends de la nourriture");
               break;
         
            case (ETAT_EN_INCUBATION) :
            
               if (etatSecondaire==500) {
                  simu.creerFourmi(fourmiliere, (int)x, (int)y, fourmiliere.getPopulation()+1, idGroup);
						fourmiliere.augmentePopulation();
                  System.out.println("Larve "+getId()+"("+getIdGroup()+") : Je me transforme en ouvriere");
						etatSecondaire = 0;
                  etatPrimaire = ETAT_ATTENTE_INCUBATION;
               }
               else
                  etatSecondaire++;
               break;
         }
      }
   
       public void stopperIncubation() {
         etatPrimaire = ETAT_ATTENTE_INCUBATION;
      }
   	
       public void lancerIncubation() {
         etatPrimaire = ETAT_EN_INCUBATION;
      }
   	
       public boolean disponible() {
         return (etatPrimaire == ETAT_ATTENTE_INCUBATION);
      }
   
   //------------------------------------------------------------
   /** 
   * Dessin 2D de l'objet 
   */
       public void draw(Graphics g, double facteurZoom) {
         g.setColor(new Color (getRed(), getGreen(), getBlue()));
         g.fillRect((int)(x*facteurZoom), (int)(y*facteurZoom), 
               (int)(2*(facteurZoom+1)), (int)(2*(facteurZoom+1))) ;
      }
   }